import { LifecycleState } from '../Lifecycle';
import { SingletonDefinition } from './SingletonDefinition';
import { ObjectDefinition } from './ObjectDefinition';
export declare class BaseSingletonState extends LifecycleState {
    static INSTANTIATING: BaseSingletonState;
    static INSTANTIATED: BaseSingletonState;
    static PROPERTIES_SET: BaseSingletonState;
}
export declare enum ParamType {
    Value = 0,
    Reference = 1,
    Type = 2,
    TypeArray = 3,
    Config = 4,
}
export declare class BaseSingletonDefinition<T> extends SingletonDefinition<T> {
    private static getMaxStateInstance(def, trace, postLoad);
    private startFunctionName;
    private shutdownFunctionName;
    private constructorArgDefinitions;
    private propertiesToSetDefinitions;
    constructor(clazz: any, name?: any, logger?: any);
    constructorParamByValue(value: any): this;
    constructorParamByConfig(key: string): this;
    constructorParamByRef(name: any): this;
    constructorParamByType(clazz: any): this;
    constructorParamByTypeArray(clazz: any): this;
    startFunction(startFunctionName: any): this;
    stopFunction(shutdownFunctionName: any): this;
    setPropertyByValue(paramName: any, value: any): this;
    setPropertyByConfig(paramName: any, key: any): this;
    setPropertyByRef(paramName: any, name: any): this;
    setPropertyByType(paramName: any, className: any): this;
    setPropertyByTypeArray(paramName: any, className: any): this;
    getInstance(): Promise<T>;
    getInstanceWithTrace(trace: any, postLoad: any): Promise<T>;
    getInstanceAtState(minState: BaseSingletonState, trace: any, postLoad: any): Promise<T>;
    protected doStart(): Promise<void>;
    protected doStop(): Promise<void>;
    protected resolveArgs(constructorArgs: any, trace: any, postLoad: Set<ObjectDefinition<any>>): Promise<any[]>;
    getCopyInstance(): ObjectDefinition<T>;
    protected copyInternalProperties(copyTo: any): void;
    private instantiate(trace, postLoad);
    private setAllProperties(trace, postload);
}
